<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE topic PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
<topic id="pdf-xslt-extensions-pub-template_usecase_6_wrap_scientific_numbers_in_tables">
  <title>How to Wrap Scientific Numbers in Tables Cells</title>
  <body>
    <p>In your PDF output, you may need to wrap scientific numbers on two lines when they are
      included in table cells.</p>
    <p id="p_cdq_cgk_54b">To add this functionality, use an <i>Oxygen Publishing Template</i> and
      follow these steps:<ol id="ol_gjr_kq5_njb">
        <li conkeyref="reusables-dcpp/pt-li1" id="li_ddq_cgk_54b"/>
        <li conkeyref="reusables-dcpp/pt-li2" id="li_edq_cgk_54b"/>
        <li conkeyref="reusables-dcpp/pt-li3" id="li_fdq_cgk_54b"/>
        <li id="li_gdq_cgk_54b">In the newly created folder, create an XSL file (for example, named
            <filepath>merged2html5Extension.xsl</filepath>) with the following
          content:<codeblock  id="codeblock_hdq_cgk_54b">&lt;?xml version="1.0" encoding="UTF-8"?>
&lt;xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:xs="http://www.w3.org/2001/XMLSchema"
  exclude-result-prefixes="xs"
  version="2.0">

  &lt;!-- Matches text from table cells. -->
  &lt;xsl:template match="*[contains(@class, ' topic/entry ') ]/text()">
    &lt;xsl:analyze-string select="." regex="[0-9]\.[0-9]{{2}}e-[0-9]{{2}}">
      &lt;!-- The cell contains a scientific number like 1.23e-08. -->
      &lt;xsl:matching-substring>
        &lt;xsl:variable name="text" select="concat(substring-before(., 'e'),
          'e&amp;#8203;', substring-after(., 'e'))"/>
        &lt;xsl:value-of select="$text"/>
      &lt;/xsl:matching-substring>
      &lt;xsl:non-matching-substring>
        &lt;xsl:value-of select="."/>
      &lt;/xsl:non-matching-substring>
    &lt;/xsl:analyze-string>
  &lt;/xsl:template>

&lt;/xsl:stylesheet></codeblock></li>
        <li id="li_idq_cgk_54b">Open the <xref
            href="pdf_publishing_template_contents.dita#template_descritpor_file_pdf"><i>template
              descriptor file</i></xref> associated with your <i>publishing template</i> (the
            <i>.opt</i> file) and set the XSLT stylesheet created in the previous step with the
            <codeph>com.oxygenxml.pdf.css.xsl.merged2html5</codeph> XSLT extension
          point:<codeblock  id="codeblock_jdq_cgk_54b">&lt;publishing-template&gt;
  ...
  &lt;pdf&gt;
    ...        
    &lt;xslt&gt;
      &lt;extension
        id="com.oxygenxml.pdf.css.xsl.merged2html5"/>
        file="xslt/merged2html5Extension.xsl"
    &lt;/xslt&gt;</codeblock></li>
        <li conkeyref="reusables-dcpp/pt-li6" id="li_kdq_cgk_54b"/>
        <li conkeyref="reusables-dcpp/pt-li7" id="li_ldq_cgk_54b"/>
        <li conkeyref="reusables-dcpp/pt-li8" id="li_mdq_cgk_54b"/>
      </ol></p>
  </body>
</topic>
